/* Parse command line arguments for bison,
   copyright (C) 1984 Bob Corbett and Richard Stallman

   Permission is granted to anyone to make or distribute verbatim copies of this program
   provided that the copyright notice and this permission notice are preserved;
   and provided that the recipient is not asked to waive or limit his right to
   redistribute copies as permitted by this permission notice;
   and provided that anyone possessing an executable copy
   is granted access to copy the source code, in machine-readable form,
   in some reasonable manner.

   Permission is granted to distribute derived works or enhanced versions of
   this program under the above conditions with the additional condition
   that the entire derivative or enhanced work
   must be covered by a permission notice identical to this one.

   Anything distributed as part of a package containing portions derived
   from this program, which cannot in current practice perform its function usefully
   in the absense of what was derived directly from this program,
   is to be considered as forming, together with the latter,
   a single work derived from this program,
   which must be entirely covered by a permission notice identical to this one
   in order for distribution of the package to be permitted.

 In other words, you are welcome to use, share and improve this program.
 You are forbidden to forbid anyone else to use, share and improve
 what you give them.   Help stamp out software-hoarding!  */

#include <stdio.h>
#include "files.h"

int verboseflag;
int definesflag;



getargs(argc, argv)
int argc;
char *argv[];
{
  register int i;
  register char *cp;
  register int duplicates;

  verboseflag = 0;
  definesflag = 0;
  duplicates = 0;

  i = 1;
  while (i < argc && *argv[i] == '-')
    {
      cp = argv[i] + 1;
      while (*cp)
	{
	  switch (*cp)
	    {
	    case 'v':
	    case 'V':
	      if (verboseflag)
		duplicates = 1;
	      else
		verboseflag = 1;
	      break;

	    case 'd':
	    case 'D':
	      if (definesflag)
		duplicates = 1;
	      else
		definesflag = 1;
	      break;

	    default:
	      fatals("illegal option:  %s", argv[i]);
	    }
	  cp++;
	}
      i++;
    }

  if (duplicates)
    fprintf(stderr, "repeated arguments");

  if (i == argc)
    fatal("grammar file not specified");
  else
    infile = argv[i];

  if (i < argc - 1)
    fprintf(stderr, "extra arguments");
}
